var _PLACEHOLDER_MAP;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// form-item 类型
var FORM_ITEM_TYPE = {
  INPUT_NUMBER: 'InputNumber',
  // 数字输入，暂时无用
  INPUT: 'Input',
  // 单行输入
  TEXTAREA: 'Textarea',
  // 多行输入
  RADIO: 'Radio',
  // 单选
  SELECT: 'Select',
  // 下拉单选
  SELECT_MULTIPLE: 'SelectMultiple',
  // 下拉多选
  CASCADER: 'Cascader',
  // 级联选择
  DATE_RANGE: 'DateRange',
  // 日期区间选择器
  FILE_UPLOAD: 'FileUpload',
  // 文件上传
  SUGGEST: 'Suggest',
  // 建议搜索
  COMPACT_INPUT: 'CompactInput' // 组合输入（包含输入框和建议选择）

}; // 输入提示

var PLACEHOLDER_MAP = (_PLACEHOLDER_MAP = {}, _defineProperty(_PLACEHOLDER_MAP, FORM_ITEM_TYPE.FILE_UPLOAD, '请上传'), _defineProperty(_PLACEHOLDER_MAP, FORM_ITEM_TYPE.SUGGEST, '请输入'), _PLACEHOLDER_MAP); // 选择类型列表

var CHOOSE_TYPE_LIST = [FORM_ITEM_TYPE.RADIO, FORM_ITEM_TYPE.SELECT, FORM_ITEM_TYPE.SELECT_MULTIPLE, FORM_ITEM_TYPE.SUGGEST, FORM_ITEM_TYPE.CASCADER, FORM_ITEM_TYPE.DATE_RANGE]; // 是选择类型

function isChooseType(type) {
  return CHOOSE_TYPE_LIST.includes(type);
} // 获取默认等输入提示


function getDefaultPlaceholder(type) {
  if (PLACEHOLDER_MAP[type]) {
    return PLACEHOLDER_MAP[type];
  }

  return isChooseType(type) ? '请选择' : '请输入';
}

export { FORM_ITEM_TYPE, isChooseType, getDefaultPlaceholder };