function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/**
 * @Date: 2020/11/25 8:53 下午
 * @Author: Fioanna
 * @Description: 搜索表格页面的混入，当SearchTable组件无法满足使用需求时，可以倒入此混入
 */
export default {
  name: 'SearchTableMixin',
  data: function data() {
    return {
      // 搜索条的搜索内容
      queryParam: {}
    };
  },
  methods: {
    /**
     * 搜索
     * @param queryParam 搜索条件
     * @private
     */
    _search: function _search(queryParam) {
      // console.log('~~~_search~~~', queryParam)
      this.queryParam = queryParam;
      this.refresh(true);
    },

    /**
     * 表格的data参数需要传入此方法，合并了搜索参数
     * @param parameter
     */
    loadList: function loadList(parameter) {
      return this.getDataList(_extends({}, parameter, this.queryParam));
    },

    /**
     * 表格重新加载方法
     * 如果参数为 true, 则强制刷新到第一页
     * @param Boolean bool
     */
    refresh: function refresh() {
      var bool = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      if (this.$refs.table) {
        this.$refs.table.refresh(bool);
      }
    },

    /**
     * 获取列表数据的协议，需重写
     * @param parameter
     * @returns {Promise<{count: number, list: []}>}
     */
    // eslint-disable-next-line
    getDataList: function getDataList(parameter) {
      return Promise.resolve({
        count: 0,
        list: []
      });
    }
  }
};