"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _babelHelperVueJsxMergeProps = _interopRequireDefault(require("babel-helper-vue-jsx-merge-props"));

var _input = _interopRequireDefault(require("ant-design-vue/es/input"));

var _types = _interopRequireDefault(require("./types"));

require("./style.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * @Date: 2020/11/23 8:12 下午
 * @Author: Fioanna
 * @Description: 带文字长度展示的输入框
 */
var _default = {
  name: 'EInput',
  props: _types["default"],
  data: function data() {
    return {
      value_: this.$props.value
    };
  },
  computed: {
    length: function length() {
      var value = '';

      if (this.value_) {
        value = this.value_ + '';
      }

      return value.length + '/' + this.$props.maxLength;
    }
  },
  methods: {
    _change: function _change(e) {
      this.value_ = e.target.value || '';
      this.$emit('input', this.value_);
      this.$emit('change', this.value_);
    },
    _blur: function _blur(e) {
      this.$emit('blur', e);
    },
    _renderInput: function _renderInput() {
      var h = this.$createElement;
      return h(_input["default"], (0, _babelHelperVueJsxMergeProps["default"])([{
        props: this.$props
      }, {
        on: {
          "change": this._change,
          "blur": this._blur
        }
      }]));
    }
  },
  render: function render() {
    var h = arguments[0];
    var showLimit = this.$props.maxLength > 0;

    if (showLimit) {
      return h("div", {
        "class": "e-input"
      }, [h("div", {
        "class": "input-wrapper"
      }, [this._renderInput(), h("span", {
        "class": "e-input-limit"
      }, [this.length])])]);
    } else {
      return this._renderInput();
    }
  }
};
exports["default"] = _default;